'======================================================================
' Copyright (C) 2022 Actiphy, Inc. All rights reserved.
'
'THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF NetJapan, Inc.
'The copyright notice above does not evidence any actual or intended
'publication of such source code.

'Abstract: Support Information collecting tool

'File: ActiveVisor_support.vbs

'Date:  05/11/2022

'Qualified Platforms:
'Windows 7 or higher

'Requirements:
'- ActiveVisor 2022 or later
'======================================================================

Option Explicit
'On Error Resume Next

'---------Check the OS Version---------
Function GetOSVersion

	Dim Wmi 
	Dim colTarget
	Dim strComputer
	Dim strWork 
	Dim objRow
	Dim aData

	strComputer = "."
	Set Wmi = GetObject("winmgmts:" _
	& "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
	
	Set colTarget = Wmi.ExecQuery( "select Version from Win32_OperatingSystem" )
	For Each objRow In colTarget
		strWork = objRow.Version
	Next

	aData = Split( strWork, "." )
	strWork = aData(0) & "." & aData(1)

	GetOSVersion = CDbl( strWork )
End Function
'---------------------------------------------------

Dim objFileSys
Dim objWshShell
Dim res
Dim strVal
Dim strPathExe
Dim strPath
Dim strCommand
Dim objTemp
Dim tempfolder
Dim zipfolder
Dim tempsub

Set objWshShell = WScript.CreateObject("WScript.Shell")
Set objFileSys = CreateObject("Scripting.FileSystemObject")
Set objTemp = objFileSys.GetSpecialFolder(2)

objWshShell.Run("cmd /c " & "echo %date% %time% ===== Script Start. ===== >> %temp%\av_tracelog.txt"),0,True

tempfolder = wscript.Arguments(0)
zipfolder = wscript.Arguments(1)
tempsub = tempfolder & "\" & "temp"

If WScript.Arguments.Count <> 2 Then
	objWshShell.Run("cmd /c " & "echo %date% %time% Missing argments. >> %temp%\av_tracelog.txt"),0,True
	WScript.Quit
Else 
	objWshShell.Run("cmd /c " & "echo %date% %time% Exist argments. >> %temp%\av_tracelog.txt"),0,True
End If

'---------Check the Installed ActiveVisor.---------
Dim strComputer
Dim objReg
Dim strKeyPath
Dim strValueName
Dim Return
Dim strValue
const HKEY_LOCAL_MACHINE = &H80000002

strComputer = "."
Set objReg=GetObject("winmgmts:{impersonationLevel=impersonate}!\\"&_
	strComputer & "\root\default:StdRegProv")
strKeyPath = "SOFTWARE\Actiphy\ActiveVisor"
strValueName = "InstallLocation"
objReg.GetStringValue HKEY_LOCAL_MACHINE,strKeyPath,strValueName,strValue
	If IsNull(strValue) Then
		Call CreateFolder
		Call OSInfo
		Call ITLogs
	Else 
		strPath = Left( strValue, InstrRev( strValue, "\" ) )
		strPathExe = strPath & "AipControl.exe"
		Call CreateFolder
		Call OSInfo
		Call ActiveVisorInfo
	End If
'---------------------------------------------------


'=================================================================================
'Create Folder
'=================================================================================
Sub CreateFolder

'Existing ActiveVisor_support folder confirmation
'Create ActiveVisor_support folder
If Not objFileSys.FolderExists(tempfolder) Then
	objFileSys.CreateFolder(tempfolder)
	objFileSys.CreateFolder(tempsub)
	objFileSys.CreateFolder(tempsub & "\" & "system")
	objFileSys.CreateFolder(tempsub & "\" & "reg")
Else
	If objFileSys.FolderExists(tempsub) Then
		objFileSys.DeleteFolder(tempsub)
		WScript.Sleep(500)
	End If
	objFileSys.CreateFolder(tempsub)
	objFileSys.CreateFolder(tempsub & "\" & "system")
	objFileSys.CreateFolder(tempsub & "\" & "reg")
End If
objWshShell.Run("cmd /c " & "echo %date% %time% Create ActiveVisor_support folder. >> %temp%\av_tracelog.txt"),0,True

End Sub
'=================================================================================

'=================================================================================
'OS
'=================================================================================
Sub OSInfo

'Save driver folder.
objWshShell.Run("xcopy /i /e /h %windir%\System32\drivers\etc """ & tempsub & "\" & "system\etc"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Save driver folder. >> %temp%\av_tracelog.txt"),0,True

'Save Systeminfo1.
objWshShell.Run("""%CommonProgramFiles%\Microsoft Shared\MSInfo\msinfo32.exe"" /nfo """ & tempsub & "\" & "system\sysinfo.nfo"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Save Systeminfo1. >> %temp%\av_tracelog.txt"),0,True

'Save Systeminfo2.
	If GetOSVersion() > 5 Then		'Not perform in Win2000.
		objWshShell.Run("cmd /c systeminfo > """ & tempsub & "\" & "system\systeminfo.txt"""),0,True
		objWshShell.Run("cmd /c " & "echo %date% %time% Save Systeminfo2. >> %temp%\av_tracelog.txt"),0,True
	End If

'Save  servermanagercmd -query.
objWshShell.Run("cmd /c servermanagercmd -query >  """ & tempsub & "\" & "system\servermanagercmd.txt"),0,False
objWshShell.Run("cmd /c " & "echo %date% %time% Collect servermanagercmd. >> %temp%\av_tracelog.txt"),0,True


'Collect Windows Eventlog.
Dim objComputer
Dim strComputer
Dim objWMIServiceA
Dim objWMIServiceB
Dim colLogFilesA
Dim colLogFilesB
Dim objLogfileA
Dim objLogfileB
Dim errBackupLogA
Dim errBackupLogB
strComputer = "." 
Set objComputer = WScript.CreateObject("WScript.Network")

Set objWMIServiceA = GetObject("winmgmts:" & "{impersonationLevel=impersonate,(Backup)}!\\" & strComputer & "\root\cimv2") 
Set objWMIServiceB = GetObject("winmgmts:" & "{impersonationLevel=impersonate,(Backup)}!\\" & strComputer & "\root\cimv2") 


'Collect Windows application Eventlog.
Set colLogFilesA = objWMIServiceA.ExecQuery ("Select * from Win32_NTEventLogFile where LogFileName='Application'") 
For Each objLogfileA In colLogFilesA 
	errBackupLogA = objLogfileA.BackupEventLog(objFileSys.GetAbsolutePathName(tempsub & "\system") & "\" & "application.evt")
Next 
objWshShell.Run("cmd /c " & "echo %date% %time% Collect Windows application Eventlog. >> %temp%\av_tracelog.txt"),0,True

'Collect Windows system Eventlog.
Set colLogFilesB = objWMIServiceB.ExecQuery ("Select * from Win32_NTEventLogFile where LogFileName='System'") 
For Each objLogfileB In colLogFilesB 
	errBackupLogB = objLogfileB.BackupEventLog(objFileSys.GetAbsolutePathName(tempsub & "\system") & "\" & "system.evt")
Next 
objWshShell.Run("cmd /c " & "echo %date% %time% Collect Windows system Eventlog. >> %temp%\av_tracelog.txt"),0,True

'Collect ipconfig.
objWshShell.Run("cmd /c ipconfig /all >  """ & tempsub & "\" & "system\ipconfig.txt""") ,0,False
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ipconfig. >> %temp%\av_tracelog.txt"),0,True

'Collect hotfix info.
	If GetOSVersion() > 5 Then		'Not perform Win2000.
		objWshShell.Run("cmd /c wmic qfe list /format:htable > """ & tempsub & "\" & "system\qfelist.htm"""),0,True
	End If
objWshShell.Run("cmd /c " & "echo %date% %time% Collect hotfix info. >> %temp%\av_tracelog.txt"),0,True

End Sub
'=================================================================================


'=================================================================================
'ActiveVisor is not installed.
'=================================================================================
Sub ITLogs

'Check ActiveVisor
objWshShell.Run("cmd /c " & "echo ActiveVisor is not installed. > """ & tempsub & "\" & "\ActiveVisor_is_not_installed.txt"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Check ActiveVisor. >> %temp%\av_tracelog.txt"),0,True

'IT edition Log
objWshShell.Run("xcopy /i /e /h %windir%\temp\logs """ & tempsub & "\" & "system\logs"""),0,True
objWshShell.Run("xcopy /i %windir%\temp\aip.log """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% IT edition Log >> %temp%\av_tracelog.txt"),0,True

End Sub
'=================================================================================


'=================================================================================
'AIP is installed.
'=================================================================================
 Sub ActiveVisorInfo
 
 Dim obj

 Const CSIDL_APPDATA = 26
 Set obj = WScript.CreateObject("Shell.Application")
 
'Collect ActiveVisor task logs.
objWshShell.Run("xcopy /i /s /e /h" & " """ & strPath & "logs"" """ & tempsub & "\" & "logs"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor task logs. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor Templates folder.
objWshShell.Run("xcopy /i /s /e /h" & " """ & strPath & "Templates"" """ & tempsub & "\" & "Templates"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor Templates folder. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor config folder.
objWshShell.Run("xcopy /i /s /e /h" & " """ & strPath & "config"" """ & tempsub & "\" & "config"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor config folder. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor AIPClients folder.
objWshShell.Run("robocopy " & """" & strPath & "AIPClients"" """ & tempsub & "\AIPClients""" & " " & "/mir /xd AIPDatas"),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor AIPClients folder. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor AIPClients db files.
objWshShell.Run("xcopy /i" & " """ & strPath & "AIPClients""*.db"" """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect AIPClients db files. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor db files.
objWshShell.Run("xcopy /i" & " """ & strPath & "*.db"" """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect db files. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor logs.
objWshShell.Run("xcopy /i" & " """ & strPath & "*.log"" """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor logs. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisorinstalllog.log
objWshShell.Run("xcopy /i C:\Windows\aipinstalllog.log """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect aipinstalllog.log >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor's ini files.
objWshShell.Run("xcopy /i" & " """ & strPath & "*.ini"" """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor's ini files. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor's serviceinfo.
'objWshShell.Run("cmd /c " & " """ & strPathExe & """ " & "" & "serviceinfo > """ & tempsub & "\serviceinfo.txt"""),0,True
objWshShell.Run("cmd /c " & """" & strPathExe & """ " & "" & "serviceinfo > C:\Windows\Temp\serviceinfo.txt"),0,True
objWshShell.Run("xcopy /i C:\Windows\Temp\serviceinfo.txt """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor's serviceinfo. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor's diskinfo.
'objWshShell.Run("cmd /c " & " """ & strPathExe & """ " & "" & "diskinfo > """ & tempsub & "\diskinfo.txt"""),0,True
objWshShell.Run("cmd /c " & """" & strPathExe & """ " & "" & "diskinfo > C:\Windows\Temp\diskinfo.txt"),0,True
objWshShell.Run("xcopy /i C:\Windows\Temp\diskinfo.txt """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor's diskinfo. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor's licensecheck.
'objWshShell.Run("cmd /c " & " """ & strPathExe & """ " & "" & "licensecheck > """ & tempsub & "\licensecheck.txt"""),0,True
objWshShell.Run("cmd /c " & """" & strPathExe & """ " & "" & "licensecheck > C:\Windows\Temp\licensecheck.txt"),0,True
objWshShell.Run("xcopy /i C:\Windows\Temp\licensecheck.txt """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor's licensecheck. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor's config.
'objWshShell.Run("cmd /c " & " """ & strPathExe & """ " & "" & "config * > """ & tempsub & "\config.txt"""),0,True
objWshShell.Run("cmd /c " & """" & strPathExe & """ " & "" & "config * > C:\Windows\Temp\config.txt"),0,True
objWshShell.Run("xcopy /i C:\Windows\Temp\config.txt """ & tempsub & "\"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor's config. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor's Dir info.
objWshShell.Run "cmd /c " & "dir" & " """& strPath & """ " & "/q /s /O:g > """ & tempsub & "\ActiveVisor_dir.txt""",0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor's Dir info. >> %temp%\av_tracelog.txt"),0,True

'Collect ActiveVisor AIPClients folder.""" & tempsub & "\" & "system\etc"""
objWshShell.Run("xcopy /i /s /e /h" & " """ & obj.Namespace(CSIDL_APPDATA).Self.Path & "\ActiveVisor"" """ & tempsub & "\Roaming\ActiveVisor"""),0,True
objWshShell.Run("cmd /c " & "echo %date% %time% Collect ActiveVisor's Roming\ActiveVisor logs. >> %temp%\av_tracelog.txt"),0,True

'Export regs(Aip2, AipNotify, AipService, AipTrack, RemoteComputers, VSS).
objWshShell.Run("regedit /e " & " """ & tempsub &"\reg\MCNotify.reg"" HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\MCNotify"),0,False
WScript.Sleep (500)
objWshShell.Run("regedit /e " & " """ & tempsub &"\reg\MCService.reg"" HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\services\MCService"),0,False
WScript.Sleep (500)

End Sub
'=================================================================================

'Added take measures: Permission denied(Code: 800A0046) 05/2/15 
Set objWshShell = Nothing
Set objFileSys = Nothing

'-------------Move ActiveVisor_support folder.-------------
Set objWshShell = WScript.CreateObject("WScript.Shell")
Set objFileSys = CreateObject("Scripting.FileSystemObject")

Dim strMoveFrom
Dim strMoveTo
Dim ActiveVisorFolder

'Set the folder name of the source and destination in a variable.
strMoveFrom = tempsub
'strMoveTo = objWshShell.SpecialFolders("Desktop")
strMoveTo = tempfolder


'Move ActiveVisor_support folder.
'Added measures: Permission denied(Code: 800A0046) 05/20/15 

ActiveVisorFolder = strMoveTo & "\" & zipfolder
WScript.sleep(1000) 'Added sleep 05/20/15 

On Error Resume Next
Dim count
count = 0
Do until count = 10
 	objFileSys.MoveFolder strMoveFrom,ActiveVisorFolder
	If Err.Number = 70 Then 
		WScript.sleep(2000)
		count = count + 1
		objWshShell.Run("cmd /c " & "echo %date% %time% MoveFolder was retried. >> %temp%\av_tracelog.txt"),0,True
		If count = 10 Then
			objWshShell.Run("cmd /c " & "echo %date% %time% MoveFolder was retried 10 times, but write error has occurred. >> %temp%\av_tracelog.txt"),0,True
			WScript.Quit
		End If
	Else
		Exit Do
	End If
Loop
On Error GoTo 0 

objWshShell.Run("cmd /c " & "echo %date% %time% Move ActiveVisor_support folder. >> %temp%\av_tracelog.txt"),0,True


WScript.Sleep (2000)


'---------Folder compression.---------
'Compress later than Windows XP.

Dim files(0)

'Path of the compressed folder.
files(0) = ActiveVisorFolder

'Calling of compress routine.The file name after compression.
Call MakeZip(files(0) & ".zip",files)

'Compress routine
Sub MakeZip(ByVal ZipPath, ByRef FileArray)

Dim sfo
Dim app
Dim file
Dim num
Dim zipFolder

Set sfo=CreateObject("Scripting.FileSystemObject")
Set app=CreateObject("Shell.Application")

'If there is an old same name compressed file, delete it.
If sfo.FileExists(ZipPath) = True Then
sfo.DeleteFile ZipPath
End If

'Create Blank zip file.
With sfo.CreateTextFile(ZipPath, True)
.Write "PK" & Chr(5) & Chr(6) & String(18,0)
.Close
End With

'--------Copy compressed folder to zip file--------
num=0

'Set the zip file Path to a variable.
Set zipFolder=app.NameSpace(sfo.GetAbsolutePathName(ZipPath))
For Each file In FileArray
If CStr(file)<>"" Then
file = sfo.GetAbsolutePathName(file)

'Copy compressed folder to zip file.
zipFolder.CopyHere(file)

'Count up files.
num=num+1
End If
Next

'Wait for copy to zip file.
Do Until zipFolder.Items().Count=num
WScript.sleep(100)
Loop

Set sfo = Nothing
Set app = Nothing

End Sub


WScript.Sleep (2000)

'---------Delete support Folder ---------
Dim strRmFolder

strRmFolder = ActiveVisorFolder
Set objFileSys = WScript.CreateObject("Scripting.FileSystemObject")
	If Err.Number = 0 Then
		objFileSys.DeleteFolder strRmFolder, True
	End If

Set objWshShell = Nothing
Set objFileSys  = Nothing